; Multi_Key Test program v1.0.  This shows off the capabilities of Multi_Key.

; Written by Thomas J. Hruska (C) 1997 Shining Light Productions

#include "ti86asm.inc"
#include "multikey.h"

#define Multi_Key(addr)   push bc \ ld bc,addr \ call MULTIKEY \ pop bc


.org _asm_exec_ram
  di
  res appAutoScroll,(iy+appflags); sets a flag so that text on the last line is not scrolled
  call _clrLCD
  ld hl,$0000
  ld (_curRow),hl
  set 3,(IY+05)
  ld hl,Title
  call _puts
  res 3,(IY+05)
  ld hl,$0003
  ld (_curRow),hl
  ld hl,Main
  call _puts  
KeyLoop:
  Multi_Key(KEY_24)
  CALL NZ,LeftPressed
  Multi_Key(KEY_24)
  CALL Z,LeftReleased
  Multi_Key(KEY_25)
  CALL NZ,UpPressed
  Multi_Key(KEY_25)
  CALL Z,UpReleased
  Multi_Key(KEY_26)
  CALL NZ,RightPressed
  Multi_Key(KEY_26)
  CALL Z,RightReleased
  Multi_Key(KEY_34)
  CALL NZ,DownPressed
  Multi_Key(KEY_34)
  CALL Z,DownReleased
  Multi_Key(KEY_22)
  CALL NZ,MODEPressed
  Multi_Key(KEY_22)
  CALL Z,MODEReleased
  Multi_Key(KEY_45)
  ret nz
  jp KeyLoop

LeftPressed:
  ld hl,$0803
DispPressed:
  ld (_curRow),hl
  ld hl,KeyOn
  call _puts
  ret
UpPressed:
  ld hl,$0804
  jr DispPressed
RightPressed:
  ld hl,$0805
  jr DispPressed
DownPressed:
  ld hl,$0806
  jr DispPressed
MODEPressed:
  ld hl,$0807
  jr DispPressed

LeftReleased:
  ld hl,$0803
DispReleased:
  ld (_curRow),hl
  ld hl,KeyOff
  call _puts
   ret
UpReleased:
  ld hl,$0804
  jr DispReleased
RightReleased:
  ld hl,$0805
  jr DispReleased
DownReleased:
  ld hl,$0806
  jr DispReleased
MODEReleased:
  ld hl,$0807
  jr DispReleased

#include "multikey.inc"

Title:
 .DB " Multi-Key Test      "
 .DB "By Thomas Hruska     "
 .DB "  CLEAR  quits       ",0

Main:
 .DB "Left :               "
 .DB "Up   :               "
 .DB "Right:               "
 .DB "Down :               "
 .DB "exit :               ",0

KeyOn:  .DB "Pressed ",0
KeyOff: .DB "Released",0

.END
